package edu.depaul.se.mdb;

import edu.depaul.se.sessionbean.CalculatorBean;
import edu.depaul.se.xml.CalculatorRequest;
import java.io.StringReader;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.EJB;
import javax.ejb.MessageDriven;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;
import static edu.depaul.se.xml.CalculatorRequest.*;

@MessageDriven(mappedName = "jms/javaee6/Queue", activationConfig = {
    @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
    @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue")
})
public class CalculatorListener implements MessageListener {
    @EJB
    private CalculatorBean calculatorBean;
    
    public CalculatorListener() {
    }
    
    @Override
    public void onMessage(Message message) {
        StringReader reader = null;
        CalculatorRequest c = null;
        
        try {
            TextMessage msgAsTextMessage = (TextMessage) message;
            JAXBContext context = JAXBContext.newInstance(CalculatorRequest.class);
            Unmarshaller m = context.createUnmarshaller();
            reader = new StringReader(msgAsTextMessage.getText());
            c = (CalculatorRequest) m.unmarshal(reader);
            
        } catch (JMSException ex) {
            Logger.getLogger(CalculatorListener.class.getName()).log(Level.SEVERE, null, ex);
        } catch (JAXBException ex) {
            Logger.getLogger(CalculatorListener.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            reader.close();
        }
        
        int result = 0;
        switch (c.getOperator()) {                
            case MULTIPLY:
                result = calculatorBean.multiply(c.getRhs(), c.getLhs());
                break;
            case SUBTRACT:
                result = calculatorBean.subtract(c.getRhs(), c.getLhs());
                break;
            case ADD:
                result = calculatorBean.add(c.getRhs(), c.getLhs());
                break;
        }

        System.out.println("Calculator result: " + result);
    }
}
