package edu.depaul.se.xml;

import javax.xml.bind.JAXBContext;
import org.junit.*;
import static org.junit.Assert.*;
import static edu.depaul.se.xml.CalculatorRequest.*;
import java.io.StringReader;
import java.io.StringWriter;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;

public class CalculatorRequestTest {
    
    public CalculatorRequestTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }
    
    private static String TWO_PLUS_FOUR_AS_XML = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?><CalculatorRequest Operator=\"ADD\"><LHS>2</LHS><RHS>4</RHS></CalculatorRequest>";

    @Test
    public void createAddXml() throws Exception {
        CalculatorRequest c = new CalculatorRequest(2, 4, CalculatorOperation.ADD);
        
        StringWriter writer = new StringWriter();
        
        JAXBContext context = JAXBContext.newInstance(CalculatorRequest.class);
        Marshaller m = context.createMarshaller();
        m.marshal(c, writer);
        assertEquals(TWO_PLUS_FOUR_AS_XML, writer.toString());
    }
    
    @Test    
    public void createObjectFromXml() throws Exception {
        JAXBContext context = JAXBContext.newInstance(CalculatorRequest.class);
        Unmarshaller m = context.createUnmarshaller();
        StringReader reader = new StringReader(TWO_PLUS_FOUR_AS_XML);
        CalculatorRequest c = (CalculatorRequest) m.unmarshal(reader);
        assertEquals(2, c.getLhs());
        assertEquals(4, c.getRhs());
        assertEquals(CalculatorOperation.ADD, c.getOperator());
    }
}
